## pd-cyclone 0.6.1

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.0)
project (cyclone C)

option(BUILD_SHARED_LIBS "Build shared libraries" ON)
option(BUILD_SINGLE_LIBRARY "Compile everything into one single library." OFF)

set(PD_INCLUDE_DIR "" CACHE PATH "Path to pure-data sources (this can be the pure-data/src folder in the sources of libpd)")
if (NOT PD_INCLUDE_DIR)
    message(FATAL_ERROR "Please provide a path to the pure-data source files.")
endif()

set(PD_LIBRARY "" CACHE PATH "Path to pure-data / libpd library (pd.lib or libpd.lib)")
if (NOT PD_LIBRARY)
    message(FATAL_ERROR "Please provide a path to the pure-data / libpd library.")
endif()

if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX "${PROJECT_SOURCE_DIR}/libs" CACHE PATH "Installation path" FORCE)
endif()

if (WIN32)
    set(CMAKE_THREAD_LIBS_INIT CACHE PATH "Path to pthreads library")
    set(PTHREADS_INCLUDE_DIR CACHE PATH "Path to the pthreads library header files")
    # We need pthreads.
    # Please provide the path to the pthreads library include path and
    # the path to the pthread library by specifying the following arguments
    # on the CMake command-line:
    # -DCMAKE_THREAD_LIBS_INIT:PATH=<path to library, either MSVC (for example pthreadVC2.lib) or GNUC version>
    # -DPTHREADS_INCLUDE_DIR:PATH=<path to the pthread header files>
    if (NOT CMAKE_THREAD_LIBS_INIT OR NOT PTHREADS_INCLUDE_DIR)
        message(FATAL_ERROR "Please provide a path to the pthreads library and its headers.")
    endif()
    set(CMAKE_THREAD_PREFER_PTHREAD ON)
endif()

if(WIN32)
    # Use Windows APIs compatible with most versions
    set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -DWINVER=0x502 -DWIN32 -D_WIN32")
endif()
if (MSVC)
    set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -DHAVE_STRUCT_TIMESPEC")
    add_definitions("/D_CRT_SECURE_NO_WARNINGS /wd4091 /wd4996")
    if(${CMAKE_SIZEOF_VOID_P} EQUAL 8)
        # Select appropriate long int type on 64-bit Windows
        set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -DPD_LONGINTTYPE=\"long long\"")
    endif()
else()
    add_definitions(-DHAVE_UNISTD_H=1)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-int-to-pointer-cast -Wno-pointer-to-int-cast")
    set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS} -ffast-math -funroll-loops -fomit-frame-pointer -O3")
    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS} -g -O0")
    if(NOT APPLE)
        set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-Bsymbolic")
    endif()
endif()

set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_MACOSX_RPATH ON)

foreach (_BUILD_TYPE RELEASE DEBUG)
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${_BUILD_TYPE} ${CMAKE_INSTALL_PREFIX})
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${_BUILD_TYPE} ${CMAKE_INSTALL_PREFIX})
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${_BUILD_TYPE} ${CMAKE_INSTALL_PREFIX})
endforeach()

include_directories(${PD_INCLUDE_DIR})
include_directories(${PTHREADS_INCLUDE_DIR})
include_directories(shared)

find_package(Threads REQUIRED)

set(CONTROL_CLASSES
    accum
    acos
    anal
    asin
    bangbang
    borax
    bucket
    cartopol
    counter
    cosh
    cycle
    decide
    decode
    flush
    forward
    fromsymbol
    funnel
    gate
    histo
    listfunnel
    linedrive
    maximum
    mean
    midiflush
    midiformat
    midiparse
    minimum
    next
    onebang
    past
    peak
    poltocar
    sinh
    spell
    split
    spray
    sprintf
    sustain
    switch
    tanh
    togedge
    trough
    universal
    unjoin
    uzi
    xbendin
    xbendin2
    xbendout
    xbendout2
    xnotein
    xnoteout
    zl
    # new ones in cyclone 0.3
    acosh
    asinh
    atanh
    atodb
    dbtoa
    join
    # FIXME loadmess needs sys_noloadbang
    pong
    pak
    rdiv
    rminus
    round
    scale

    #GUI
    comment

    # classes with dependencies
    capture
    mtr
    coll
    tosymbol
    append
    clip
    prepend
    thresh
    substitute
    speedlim
    match
    iter
    buddy
    bondo
    pv
    prob
    active
    mousefilter
    mousestate
    offer
    funbuff
    drunk
    urn
    table
    seq
    grab
)

if (MSVC)
    # Remove controls that are not compatible with MSVC
    list(REMOVE_ITEM CONTROL_CLASSES
    funbuff # needs POSIX libgen.h
    round # needs alloca
    pong # needs alloca
    )
endif(MSVC)

set(SIGNAL_CLASSES
    acos
    acosh
    allpass
    asin
    asinh
    atan
    atan2
    atanh
    average
    avg
    change
    click
    clip
    cosh
    cosx
    count
    comb
    curve
    cycle
    delta
    deltaclip
    edge
    line
    lores
    maximum
    minimum
    mstosamps
    onepole
    overdrive
    peakamp
    phasewrap
    pink
    pong
    pow
    rampsmooth
    rand
    reson
    sampstoms
    sinh
    sinx
    slide
    snapshot
    spike
    svf
    tanh
    tanx
    teeth
    train
    trapezoid
    triangle
    zerox
    # new in cyclone 0.3
    atodb
    cross
    dbtoa
    degrade
    downsamp
    equals
    greaterthan
    greaterthaneq
    lessthan
    lessthaneq
    modulo
    notequals
    phaseshift
    rdiv
    rminus
    round
    scale
    thresh
    trunc

    # classes with dependencies
    frameaccum
    framedelta
    capture
    cartopol
    delay
    plusequals
    minmax
    poltocar
    matrix
    sah
    gate
    selector
    kink
    vectral
    bitand
    bitnot
    bitor
    bitsafe
    bitshift
    bitxor
    # GUI
    scope
    buffir
    lookup
    index
    peek
    poke
    record
    wave
    play
)

add_library(cyclone_shared STATIC
    shared/common/file.h
    shared/common/file.c
    shared/common/grow.h
    shared/common/grow.c
    shared/common/magicbit.h
    shared/common/magicbit.c
    shared/control/gui.h
    shared/control/gui.c
    shared/control/mifi.h
    shared/control/mifi.c
    shared/control/rand.h
    shared/control/rand.c
    shared/control/tree.h
    shared/control/tree.c
    shared/signal/cybuf.h
    shared/signal/cybuf.c
)

link_libraries(${PD_LIBRARY})
link_libraries(${CMAKE_THREAD_LIBS_INIT})
link_libraries(cyclone_shared)

# Add main cyclone library

set(SETUP_DECLS "")
set(SETUP_CALLS "")
if(BUILD_SINGLE_LIBRARY)
    string(APPEND SETUP_DECLS "// control classes\n\n")
    string(APPEND SETUP_CALLS "    // control classes\n\n")
    foreach(NAME ${CONTROL_CLASSES})
        string(APPEND SETUP_DECLS "void ${NAME}_setup();\n")
        string(APPEND SETUP_CALLS "    ${NAME}_setup();\n")
    endforeach(NAME)
    string(APPEND SETUP_DECLS "\n// signal classes\n\n")
    string(APPEND SETUP_CALLS "\n    // signal classes\n\n")
    foreach(NAME ${SIGNAL_CLASSES})
        string(APPEND SETUP_DECLS "void ${NAME}_tilde_setup();\n")
        string(APPEND SETUP_CALLS "    ${NAME}_tilde_setup();\n")
    endforeach(NAME)
endif(BUILD_SINGLE_LIBRARY)

configure_file(cyclone_objects/binaries/single_lib.c.in
    ${CMAKE_CURRENT_BINARY_DIR}/cyclone_objects/binaries/single_lib.c)

add_library(cyclone cyclone_objects/binaries/cyclone_lib.c
    ${CMAKE_CURRENT_BINARY_DIR}/cyclone_objects/binaries/single_lib.c
)

# Add libraries for objects

if(BUILD_SHARED_LIBS AND NOT BUILD_SINGLE_LIBRARY)
    set(LIB_BUILD_MODE SHARED)
else()
    set(LIB_BUILD_MODE STATIC)
endif()

if(BUILD_SINGLE_LIBRARY)
    add_definitions(-DCYCLONE_SINGLE_LIBRARY=1)
endif()

foreach(NAME ${CONTROL_CLASSES})
    add_library(${NAME} ${LIB_BUILD_MODE} cyclone_objects/binaries/control/${NAME}.c)
endforeach(NAME)

foreach(NAME ${SIGNAL_CLASSES})
    add_library(signal_${NAME} ${LIB_BUILD_MODE} cyclone_objects/binaries/audio/${NAME}.c)
    set_target_properties(signal_${NAME} PROPERTIES OUTPUT_NAME ${NAME}~)
endforeach(NAME)

# Link objects to main library if building a single library

if(BUILD_SINGLE_LIBRARY)
    foreach(NAME ${CONTROL_CLASSES})
        target_link_libraries(cyclone ${NAME})
    endforeach(NAME)
    foreach(NAME ${SIGNAL_CLASSES})
        target_link_libraries(cyclone signal_${NAME})
    endforeach(NAME)
endif(BUILD_SINGLE_LIBRARY)

# Install

install(DIRECTORY
    cyclone_objects/abstractions/
    documentation/help_files/
    documentation/extra_files/
    DESTINATION .
    FILES_MATCHING PATTERN "*.pd"
)

install(FILES
    LICENSE.txt
    README.pdf
    DESTINATION .
)

if (MINGW)
    # pthreadGC-3.dll is required for Windows installation. It can be found in
    # the MinGW directory (usually C:\MinGW\bin) directory and should be
    # copied to the current directory before installation or packaging.

    install(FILES
        maintenance/windows_dll/pthreadGC-3.dll
        maintenance/windows_dll/libgcc_s_dw2-1.dll
        DESTINATION .
    )
endif(MINGW)

# Install upper case aliases on Linux
if(UNIX AND NOT APPLE)
    if(NOT IS_ABSOLUTE ${CMAKE_INSTALL_PREFIX})
        set(CMAKE_INSTALL_PREFIX "${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_INSTALL_PREFIX}")
    endif()

    macro(create_symlinks old new)
        if (NOT BUILD_SINGLE_LIBRARY)
            install(CODE "execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink \
                ${CMAKE_INSTALL_PREFIX}/lib${old}${CMAKE_DEBUG_POSTFIX}.so \
                ${CMAKE_INSTALL_PREFIX}/lib${new}${CMAKE_DEBUG_POSTFIX}.so)")
        endif()
        install(CODE "execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink \
            ${CMAKE_INSTALL_PREFIX}/${old}-help.pd ${CMAKE_INSTALL_PREFIX}/${new}-help.pd)")
    endmacro()

    create_symlinks(append Append)
    create_symlinks(bucket Bucket)
    create_symlinks(clip Clip)
    create_symlinks(decode Decode)
    create_symlinks(histo Histo)
    create_symlinks(mousestate MouseState)
    create_symlinks(peak Peak)
    create_symlinks(table Table)
    create_symlinks(togedge TogEdge)
    create_symlinks(trough Trough)
    create_symlinks(uzi Uzi)

    create_symlinks(clip~ Clip~)
    create_symlinks(line~ Line~)
    create_symlinks(scope~ Scope~)
    create_symlinks(snapshot~ Snapshot~)
endif(UNIX AND NOT APPLE)

=== Makefile ===
################################################################################
######## Makefile for the Cyclone library of Pure Data externals ###############
################################################################################

lib.name = cyclone

# for the MINGW which has the timespec struct defined twice
cflags = -Ishared -DHAVE_STRUCT_TIMESPEC

define forWindows
	ldlibs += -lpthread
	exe.extension = .exe
endef



forLinux   = aliases=true

#######################################################################
                    ## START OF CYCLONE CLASSES ##
#######################################################################

# CONTROL CLASSES
accum.class.sources := cyclone_objects/binaries/control/accum.c
acos.class.sources := cyclone_objects/binaries/control/acos.c
anal.class.sources := cyclone_objects/binaries/control/anal.c
asin.class.sources := cyclone_objects/binaries/control/asin.c
bangbang.class.sources := cyclone_objects/binaries/control/bangbang.c
borax.class.sources := cyclone_objects/binaries/control/borax.c
bucket.class.sources := cyclone_objects/binaries/control/bucket.c
cartopol.class.sources := cyclone_objects/binaries/control/cartopol.c
counter.class.sources := cyclone_objects/binaries/control/counter.c
cosh.class.sources := cyclone_objects/binaries/control/cosh.c
cycle.class.sources := cyclone_objects/binaries/control/cycle.c
decide.class.sources := cyclone_objects/binaries/control/decide.c
decode.class.sources := cyclone_objects/binaries/control/decode.c
flush.class.sources := cyclone_objects/binaries/control/flush.c
forward.class.sources := cyclone_objects/binaries/control/forward.c
fromsymbol.class.sources := cyclone_objects/binaries/control/fromsymbol.c
funnel.class.sources := cyclone_objects/binaries/control/funnel.c
gate.class.sources := cyclone_objects/binaries/control/gate.c
histo.class.sources := cyclone_objects/binaries/control/histo.c
listfunnel.class.sources := cyclone_objects/binaries/control/listfunnel.c
linedrive.class.sources := cyclone_objects/binaries/control/linedrive.c
maximum.class.sources := cyclone_objects/binaries/control/maximum.c
mean.class.sources := cyclone_objects/binaries/control/mean.c
midiflush.class.sources := cyclone_objects/binaries/control/midiflush.c
midiformat.class.sources := cyclone_objects/binaries/control/midiformat.c
midiparse.class.sources := cyclone_objects/binaries/control/midiparse.c
minimum.class.sources := cyclone_objects/binaries/control/minimum.c
next.class.sources := cyclone_objects/binaries/control/next.c
onebang.class.sources := cyclone_objects/binaries/control/onebang.c
past.class.sources := cyclone_objects/binaries/control/past.c
peak.class.sources := cyclone_objects/binaries/control/peak.c
poltocar.class.sources := cyclone_objects/binaries/control/poltocar.c
sinh.class.sources := cyclone_objects/binaries/control/sinh.c
spell.class.sources := cyclone_objects/binaries/control/spell.c
split.class.sources := cyclone_objects/binaries/control/split.c
spray.class.sources := cyclone_objects/binaries/control/spray.c
sprintf.class.sources := cyclone_objects/binaries/control/sprintf.c
sustain.class.sources := cyclone_objects/binaries/control/sustain.c
switch.class.sources := cyclone_objects/binaries/control/switch.c
tanh.class.sources := cyclone_objects/binaries/control/tanh.c
trough.class.sources := cyclone_objects/binaries/control/trough.c
universal.class.sources := cyclone_objects/binaries/control/universal.c
unjoin.class.sources := cyclone_objects/binaries/control/unjoin.c
uzi.class.sources := cyclone_objects/binaries/control/uzi.c
xbendin.class.sources := cyclone_objects/binaries/control/xbendin.c
xbendin2.class.sources := cyclone_objects/binaries/control/xbendin2.c
xbendout.class.sources := cyclone_objects/binaries/control/xbendout.c
xbendout2.class.sources := cyclone_objects/binaries/control/xbendout2.c
xnotein.class.sources := cyclone_objects/binaries/control/xnotein.c
xnoteout.class.sources := cyclone_objects/binaries/control/xnoteout.c
zl.class.sources := cyclone_objects/binaries/control/zl.c
# NEW ones in cyclone0.3:
acosh.class.sources := cyclone_objects/binaries/control/acosh.c
asinh.class.sources := cyclone_objects/binaries/control/asinh.c
atanh.class.sources := cyclone_objects/binaries/control/atanh.c
atodb.class.sources := cyclone_objects/binaries/control/atodb.c
dbtoa.class.sources := cyclone_objects/binaries/control/dbtoa.c
join.class.sources := cyclone_objects/binaries/control/join.c
loadmess.class.sources := cyclone_objects/binaries/control/loadmess.c
pong.class.sources := cyclone_objects/binaries/control/pong.c
pak.class.sources := cyclone_objects/binaries/control/pak.c
rdiv.class.sources := cyclone_objects/binaries/control/rdiv.c
rminus.class.sources := cyclone_objects/binaries/control/rminus.c
round.class.sources := cyclone_objects/binaries/control/round.c
scale.class.sources := cyclone_objects/binaries/control/scale.c

# SIGNAL CLASSES:
acos~.class.sources := cyclone_objects/binaries/audio/acos.c
acosh~.class.sources := cyclone_objects/binaries/audio/acosh.c
allpass~.class.sources := cyclone_objects/binaries/audio/allpass.c
asinh~.class.sources := cyclone_objects/binaries/audio/asinh.c
asin~.class.sources := cyclone_objects/binaries/audio/asin.c
atan~.class.sources := cyclone_objects/binaries/audio/atan.c
atan2~.class.sources := cyclone_objects/binaries/audio/atan2.c
atanh~.class.sources := cyclone_objects/binaries/audio/atanh.c
average~.class.sources := cyclone_objects/binaries/audio/average.c
avg~.class.sources := cyclone_objects/binaries/audio/avg.c
change~.class.sources := cyclone_objects/binaries/audio/change.c
click~.class.sources := cyclone_objects/binaries/audio/click.c
clip~.class.sources := cyclone_objects/binaries/audio/clip.c
cosh~.class.sources := cyclone_objects/binaries/audio/cosh.c
cosx~.class.sources := cyclone_objects/binaries/audio/cosx.c
count~.class.sources := cyclone_objects/binaries/audio/count.c
comb~.class.sources := cyclone_objects/binaries/audio/comb.c
curve~.class.sources := cyclone_objects/binaries/audio/curve.c
cycle~.class.sources := cyclone_objects/binaries/audio/cycle.c
delta~.class.sources := cyclone_objects/binaries/audio/delta.c
deltaclip~.class.sources := cyclone_objects/binaries/audio/deltaclip.c
edge~.class.sources := cyclone_objects/binaries/audio/edge.c
line~.class.sources := cyclone_objects/binaries/audio/line.c
lores~.class.sources := cyclone_objects/binaries/audio/lores.c
maximum~.class.sources := cyclone_objects/binaries/audio/maximum.c
minimum~.class.sources := cyclone_objects/binaries/audio/minimum.c
mstosamps~.class.sources := cyclone_objects/binaries/audio/mstosamps.c
onepole~.class.sources := cyclone_objects/binaries/audio/onepole.c
overdrive~.class.sources := cyclone_objects/binaries/audio/overdrive.c
peakamp~.class.sources := cyclone_objects/binaries/audio/peakamp.c
phasewrap~.class.sources := cyclone_objects/binaries/audio/phasewrap.c
pink~.class.sources := cyclone_objects/binaries/audio/pink.c
pong~.class.sources := cyclone_objects/binaries/audio/pong.c
pow~.class.sources := cyclone_objects/binaries/audio/pow.c
rampsmooth~.class.sources := cyclone_objects/binaries/audio/rampsmooth.c
rand~.class.sources := cyclone_objects/binaries/audio/rand.c
reson~.class.sources := cyclone_objects/binaries/audio/reson.c
sampstoms~.class.sources := cyclone_objects/binaries/audio/sampstoms.c
sinh~.class.sources := cyclone_objects/binaries/audio/sinh.c
sinx~.class.sources := cyclone_objects/binaries/audio/sinx.c
slide~.class.sources := cyclone_objects/binaries/audio/slide.c
snapshot~.class.sources := cyclone_objects/binaries/audio/snapshot.c
spike~.class.sources := cyclone_objects/binaries/audio/spike.c
svf~.class.sources := cyclone_objects/binaries/audio/svf.c
tanh~.class.sources := cyclone_objects/binaries/audio/tanh.c
tanx~.class.sources := cyclone_objects/binaries/audio/tanx.c
teeth~.class.sources := cyclone_objects/binaries/audio/teeth.c
togedge.class.sources := cyclone_objects/binaries/control/togedge.c
train~.class.sources := cyclone_objects/binaries/audio/train.c
trapezoid~.class.sources := cyclone_objects/binaries/audio/trapezoid.c
triangle~.class.sources := cyclone_objects/binaries/audio/triangle.c
zerox~.class.sources := cyclone_objects/binaries/audio/zerox.c
# NEW ones in cyclone0.3:
atodb~.class.sources := cyclone_objects/binaries/audio/atodb.c
cross~.class.sources := cyclone_objects/binaries/audio/cross.c
dbtoa~.class.sources := cyclone_objects/binaries/audio/dbtoa.c
degrade~.class.sources := cyclone_objects/binaries/audio/degrade.c
downsamp~.class.sources := cyclone_objects/binaries/audio/downsamp.c
equals~.class.sources := cyclone_objects/binaries/audio/equals.c
greaterthan~.class.sources := cyclone_objects/binaries/audio/greaterthan.c
greaterthaneq~.class.sources := cyclone_objects/binaries/audio/greaterthaneq.c
lessthan~.class.sources := cyclone_objects/binaries/audio/lessthan.c
lessthaneq~.class.sources := cyclone_objects/binaries/audio/lessthaneq.c
modulo~.class.sources := cyclone_objects/binaries/audio/modulo.c
notequals~.class.sources := cyclone_objects/binaries/audio/notequals.c
phaseshift~.class.sources := cyclone_objects/binaries/audio/phaseshift.c
rdiv~.class.sources := cyclone_objects/binaries/audio/rdiv.c
rminus~.class.sources := cyclone_objects/binaries/audio/rminus.c
round~.class.sources := cyclone_objects/binaries/audio/round.c
scale~.class.sources := cyclone_objects/binaries/audio/scale.c
thresh~.class.sources := cyclone_objects/binaries/audio/thresh.c
trunc~.class.sources := cyclone_objects/binaries/audio/trunc.c

##################### CLASSES WITH DEPENDENCIES ##################################

# Control classes: ###############################################

hfile := shared/common/file.c
capture.class.sources := cyclone_objects/binaries/control/capture.c $(hfile)
mtr.class.sources := cyclone_objects/binaries/control/mtr.c $(hfile)
coll.class.sources := cyclone_objects/binaries/control/coll.c $(hfile)

hgrow := shared/common/grow.c
tosymbol.class.sources := cyclone_objects/binaries/control/tosymbol.c $(hgrow)
append.class.sources := cyclone_objects/binaries/control/append.c $(hgrow)
clip.class.sources := cyclone_objects/binaries/control/clip.c $(hgrow)
prepend.class.sources := cyclone_objects/binaries/control/prepend.c $(hgrow)
thresh.class.sources := cyclone_objects/binaries/control/thresh.c $(hgrow)
substitute.class.sources := cyclone_objects/binaries/control/substitute.c $(hgrow)
speedlim.class.sources := cyclone_objects/binaries/control/speedlim.c $(hgrow)
match.class.sources := cyclone_objects/binaries/control/match.c $(hgrow)
iter.class.sources := cyclone_objects/binaries/control/iter.c $(hgrow)
buddy.class.sources := cyclone_objects/binaries/control/buddy.c $(hgrow)
bondo.class.sources := cyclone_objects/binaries/control/bondo.c $(hgrow)
pv.class.sources := cyclone_objects/binaries/control/pv.c $(hgrow)

hrandfile := \
shared/control/rand.c \
shared/common/file.c
prob.class.sources := cyclone_objects/binaries/control/prob.c $(hrandfile)

hgui := shared/control/gui.c
active.class.sources := cyclone_objects/binaries/control/active.c $(hgui)
mousefilter.class.sources := cyclone_objects/binaries/control/mousefilter.c $(hgui)
mousestate.class.sources := cyclone_objects/binaries/control/mousestate.c $(hgui)

htree := shared/control/tree.c
offer.class.sources := cyclone_objects/binaries/control/offer.c $(htree)

htreefile := \
shared/control/tree.c \
shared/common/file.c
funbuff.class.sources := cyclone_objects/binaries/control/funbuff.c $(htreefile)

hrand := shared/control/rand.c
drunk.class.sources := cyclone_objects/binaries/control/drunk.c $(hrand)

hrandgrow := \
shared/control/rand.c \
shared/common/grow.c
urn.class.sources := cyclone_objects/binaries/control/urn.c $(hrandgrow)

hrandgrowfile := \
shared/control/rand.c \
shared/common/grow.c \
shared/common/file.c
table.class.sources := cyclone_objects/binaries/control/table.c $(hrandgrowfile)

hseq := \
shared/control/mifi.c \

=== debian/changelog ===
pd-cyclone (0.6.1-2) unstable; urgency=medium

  * Explicitly set buildsystem to 'pd_lib_builder'
  * Apply 'wrap-and-sort -ast'

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 07 Dec 2022 10:38:44 +0100

pd-cyclone (0.6.1-1) unstable; urgency=medium

  * Fix version.

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 23 Nov 2022 17:09:12 +0100

pd-cyclone (0.6.1-1~exq) unstable; urgency=medium

  * Upload to unstable.

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 23 Nov 2022 17:00:43 +0100

pd-cyclone (0.6.1-1~exp) experimental; urgency=medium

  * New upstream version 0.6.1

  [ IOhannes m zmölnig (Debian/GNU) ]
  * Refresh patches (dropping obsolete ones)
  * Drop 'cyclist' package without replacement (abandoned upstream)
  * Switch to dh-sequence-pd-lib-builder
  * Versioned dependency on puredata-core (>=0.52-1)
  * Drop recommends no longer needed (or existing)
  * Update package description
  * Update homepage stanza
  * Update upstream/metadata
  * Update d/copyright
    + Modernize 'licensecheck' target
    + Re-generate d/copyright_hints
  * Update lintian-overrides
  * Update d/watch to new upstream repository

  [ Debian Janitor ]
  * Update lintian override info to new format on line 6.
  * Remove constraints unnecessary since buster (oldstable)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 23 Nov 2022 11:02:03 +0100

pd-cyclone (0.2~beta3-6) unstable; urgency=medium

  * Fix lintian-overrides for newer versions of lintian
  * Apply "warp-and-sort -ast"
  * Bump standards version to 4.6.1

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sun, 04 Sep 2022 13:20:37 +0200

=== debian/control ===
Source: pd-cyclone
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-buildinfo,
 dh-sequence-pd-lib-builder,
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://github.com/porres/pd-cyclone
Vcs-Git: https://salsa.debian.org/multimedia-team/pd/pd-cyclone.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/pd/pd-cyclone

Package: pd-cyclone
Architecture: any
Depends:
 puredata-core (>= 0.52.1~),
 ${misc:Depends},
 ${puredata:Depends},
 ${shlibs:Depends},
Recommends:
 ${puredata:Recommends},
Suggests:
 ${puredata:Suggests},
Description: Pd library of clones of Max/MSP objects
 Cyclone is a library of PureData classes, bringing some level of
 compatibility between Max/MSP and Pd environments.
 .
 In its current form, cyclone is mainly for people using both Max and
 Pd, and thus wanting to develop cross-platform patches.  In this
 respect, cyclone has much in common with Thomas Grill's flext, and
 flext-based externals.  While flext enables developing new
 cross-platform classes, cyclone makes existing classes cross-platform.
 .
 Cyclone also comes handy, somewhat, in the task of importing Max/MSP
 patches into Pd.  Do not expect miracles, though, it is usually not an
 easy task.

=== debian/watch ===
# process with uscan(1)
version=4
opts=uversionmangle=s/(alpha|beta)/~$1/;s/^cyclone_//;s/^\.//;s/-/./g,\
     dversionmangle=auto \
  https://github.com/porres/pd-cyclone/tags .*/(cyclone_)?v?(\d\S*)\.tar\.gz

## pd-cyclone 0.7.0+ds

=== Makefile ===
--- 
+++ 
@@ -12,13 +12,14 @@
 	exe.extension = .exe
 endef
 
-
-
 forLinux   = aliases=true
 
 #######################################################################
                     ## START OF CYCLONE CLASSES ##
 #######################################################################
+
+# CONTROL GUI
+comment.class.sources := cyclone_objects/binaries/control/comment.c
 
 # CONTROL CLASSES
 accum.class.sources := cyclone_objects/binaries/control/accum.c
@@ -32,7 +33,6 @@
 counter.class.sources := cyclone_objects/binaries/control/counter.c
 cosh.class.sources := cyclone_objects/binaries/control/cosh.c
 cycle.class.sources := cyclone_objects/binaries/control/cycle.c
-decide.class.sources := cyclone_objects/binaries/control/decide.c
 decode.class.sources := cyclone_objects/binaries/control/decode.c
 flush.class.sources := cyclone_objects/binaries/control/flush.c
 forward.class.sources := cyclone_objects/binaries/control/forward.c
@@ -72,7 +72,6 @@
 xnotein.class.sources := cyclone_objects/binaries/control/xnotein.c
 xnoteout.class.sources := cyclone_objects/binaries/control/xnoteout.c
 zl.class.sources := cyclone_objects/binaries/control/zl.c
-# NEW ones in cyclone0.3:
 acosh.class.sources := cyclone_objects/binaries/control/acosh.c
 asinh.class.sources := cyclone_objects/binaries/control/asinh.c
 atanh.class.sources := cyclone_objects/binaries/control/atanh.c
@@ -119,7 +118,6 @@
 overdrive~.class.sources := cyclone_objects/binaries/audio/overdrive.c
 peakamp~.class.sources := cyclone_objects/binaries/audio/peakamp.c
 phasewrap~.class.sources := cyclone_objects/binaries/audio/phasewrap.c
-pink~.class.sources := cyclone_objects/binaries/audio/pink.c
 pong~.class.sources := cyclone_objects/binaries/audio/pong.c
 pow~.class.sources := cyclone_objects/binaries/audio/pow.c
 rampsmooth~.class.sources := cyclone_objects/binaries/audio/rampsmooth.c
@@ -218,3 +216,5 @@
 
 hseq := \
 shared/control/mifi.c \
+shared/common/file.c \
+shared/common/grow.c

=== debian/changelog ===
pd-cyclone (0.7.0+ds-1) unstable; urgency=medium

  * New upstream version 0.7.0+ds
    + Drop patches applied upstream
  * Build for both single and double-precision Pd
  * Add patch that removes useless include causing FTBFS
  * Repack sources
    + Add '+ds' to the repacked version number
    + Exclude generated PDF files from source tarballs
    + Install README.md instead of README.pdf
  * Update copyright information
    + Update d/copyright
    + Re-generate d/copyright_hints
  * Add lintian-overrides for false-positives regarding underlinking
  * Bump standards version to 4.6.2

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 06 Jul 2023 09:03:42 +0200

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
  debhelper-compat (= 13),
  dh-buildinfo,
  dh-sequence-pd-lib-builder,
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://github.com/porres/pd-cyclone
 Vcs-Git: https://salsa.debian.org/multimedia-team/pd/pd-cyclone.git

## pd-cyclone 0.8.0+ds

=== Makefile ===
--- 
+++ 
@@ -17,9 +17,6 @@
 #######################################################################
                     ## START OF CYCLONE CLASSES ##
 #######################################################################
-
-# CONTROL GUI
-comment.class.sources := cyclone_objects/binaries/control/comment.c
 
 # CONTROL CLASSES
 accum.class.sources := cyclone_objects/binaries/control/accum.c
@@ -218,3 +215,7 @@
 shared/control/mifi.c \
 shared/common/file.c \
 shared/common/grow.c
+seq.class.sources := cyclone_objects/binaries/control/seq.c $(hseq)
+
+# New Dependencies:
+

=== debian/changelog ===
pd-cyclone (0.8.0+ds-1build1) noble; urgency=high

  * No change rebuild for frame pointers (and time_t).

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 18 Apr 2024 20:00:58 +0200

pd-cyclone (0.8.0+ds-1) unstable; urgency=medium

  * New upstream version 0.8.0+ds
    + Update d/patches
    + Drop patches obsoleted upstream
  * Update copyright information
    + Update d/copyright
    + Re-generate d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 12 Dec 2023 16:11:34 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: pd-cyclone
 Section: sound
 Priority: optional
-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
 Build-Depends:

## pd-cyclone 0.9.0+ds

=== debian/changelog ===
pd-cyclone (0.9.0+ds-2) unstable; urgency=medium

  * Add patch to fix FTBFS with gcc-14 (Closes: #1075369)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Fri, 16 Aug 2024 00:33:26 +0200

pd-cyclone (0.9.0+ds-1) unstable; urgency=medium

  * New upstream version 0.9.0+ds
    + Drop patches applied upstream
  * Re-generate d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 24 Jun 2024 10:53:59 +0200

pd-cyclone (0.8.1+ds-2) unstable; urgency=medium

  * Fix struct member types for Pd64 (Closes: #1073343)
  * Switch to dh-sequence-puredata
  * Add puredata:Provides

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 17 Jun 2024 15:43:38 +0200

pd-cyclone (0.8.1+ds-1) unstable; urgency=medium

  * New upstream version 0.8.1+ds
    + Update d/patches
  * Update copyright information
    + Bump dates in d/copyright
    + Re-generate d/copyright_hints
  * Bump standards version to 4.7.0

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 23 Apr 2024 08:03:34 +0200

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,14 @@
 Source: pd-cyclone
 Section: sound
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
 Build-Depends:
  debhelper-compat (= 13),
  dh-buildinfo,
- dh-sequence-pd-lib-builder,
-Standards-Version: 4.6.2
+ dh-sequence-puredata,
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://github.com/porres/pd-cyclone
 Vcs-Git: https://salsa.debian.org/multimedia-team/pd/pd-cyclone.git
@@ -26,6 +25,8 @@
  ${puredata:Recommends},
 Suggests:
  ${puredata:Suggests},
+Provides:
+ ${puredata:Provides},
 Description: Pd library of clones of Max/MSP objects
  Cyclone is a library of PureData classes, bringing some level of
  compatibility between Max/MSP and Pd environments.

## pd-cyclone 0.9.1%2Bds

=== debian/changelog ===
pd-cyclone (0.9.1+ds-1) unstable; urgency=medium

  * New upstream version 0.9.1+ds
    + Drop patches applied upstream
  * Break older Pd-versions, rather than Depend on a new one

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 28 Aug 2024 20:04:26 +0200

## pd-cyclone 0.9.1+ds

=== debian/control ===
--- 
+++ 
@@ -17,7 +17,6 @@
 Package: pd-cyclone
 Architecture: any
 Depends:
- puredata-core (>= 0.52.1~),
  ${misc:Depends},
  ${puredata:Depends},
  ${shlibs:Depends},
@@ -27,6 +26,8 @@
  ${puredata:Suggests},
 Provides:
  ${puredata:Provides},
+Breaks:
+ puredata-core (<< 0.52.1~),
 Description: Pd library of clones of Max/MSP objects
  Cyclone is a library of PureData classes, bringing some level of
  compatibility between Max/MSP and Pd environments.

=== debian/watch ===
# process with uscan(1)
version=4
opts=uversionmangle=s/(alpha|beta)/~$1/;s/^cyclone_//;s/^\.//;s/-/./g,\
     repacksuffix=+ds,\
     dversionmangle=auto \
  https://github.com/porres/pd-cyclone/tags .*/(cyclone_)?v?(\d\S*)\.tar\.gz

## pd-cyclone 0.9.2+ds

=== debian/changelog ===
pd-cyclone (0.9.2+ds-1) unstable; urgency=medium

  * New upstream version 0.9.2+ds
  * Update copyright information
    + Bump copyright dates
    + Re-generate d/copyright_hints
  * Update git repository layout to follow DEP-14
  * Bump standards version to 4.7.2

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 18 Mar 2025 08:45:25 +0100

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
  debhelper-compat (= 13),
  dh-buildinfo,
  dh-sequence-puredata,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://github.com/porres/pd-cyclone
 Vcs-Git: https://salsa.debian.org/multimedia-team/pd/pd-cyclone.git

## pd-cyclone 0.9.3%2Bds

=== debian/changelog ===
pd-cyclone (0.9.3+ds-1) unstable; urgency=medium

  * New upstream version 0.9.3+ds
  * Drop obsolete build dependency on dh-buildinfo
  * Fix version mangling in d/watch

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Fri, 22 Aug 2025 10:20:50 +0200

## pd-cyclone 0.9.3+ds

=== Makefile ===
--- 
+++ 
@@ -69,6 +69,37 @@
 xnotein.class.sources := cyclone_objects/binaries/control/xnotein.c
 xnoteout.class.sources := cyclone_objects/binaries/control/xnoteout.c
 zl.class.sources := cyclone_objects/binaries/control/zl.c
+zl.ecils.class.sources := cyclone_objects/binaries/control/zl.c
+zl.group.class.sources := cyclone_objects/binaries/control/zl.c
+zl.iter.class.sources := cyclone_objects/binaries/control/zl.c
+zl.join.class.sources := cyclone_objects/binaries/control/zl.c
+zl.len.class.sources := cyclone_objects/binaries/control/zl.c
+zl.mth.class.sources := cyclone_objects/binaries/control/zl.c
+zl.nth.class.sources := cyclone_objects/binaries/control/zl.c
+zl.reg.class.sources := cyclone_objects/binaries/control/zl.c
+zl.rev.class.sources := cyclone_objects/binaries/control/zl.c
+zl.rot.class.sources := cyclone_objects/binaries/control/zl.c
+zl.sect.class.sources := cyclone_objects/binaries/control/zl.c
+zl.slice.class.sources := cyclone_objects/binaries/control/zl.c
+zl.sort.class.sources := cyclone_objects/binaries/control/zl.c
+zl.sub.class.sources := cyclone_objects/binaries/control/zl.c
+zl.union.class.sources := cyclone_objects/binaries/control/zl.c
+zl.change.class.sources := cyclone_objects/binaries/control/zl.c
+zl.compare.class.sources := cyclone_objects/binaries/control/zl.c
+zl.delace.class.sources := cyclone_objects/binaries/control/zl.c
+zl.filter.class.sources := cyclone_objects/binaries/control/zl.c
+zl.lace.class.sources := cyclone_objects/binaries/control/zl.c
+zl.lookup.class.sources := cyclone_objects/binaries/control/zl.c
+zl.median.class.sources := cyclone_objects/binaries/control/zl.c
+zl.queue.class.sources := cyclone_objects/binaries/control/zl.c
+zl.scramble.class.sources := cyclone_objects/binaries/control/zl.c
+zl.stack.class.sources := cyclone_objects/binaries/control/zl.c
+zl.stream.class.sources := cyclone_objects/binaries/control/zl.c
+zl.sum.class.sources := cyclone_objects/binaries/control/zl.c
+zl.thin.class.sources := cyclone_objects/binaries/control/zl.c
+zl.unique.class.sources := cyclone_objects/binaries/control/zl.c
+zl.indexmap.class.sources := cyclone_objects/binaries/control/zl.c
+zl.swap.class.sources := cyclone_objects/binaries/control/zl.c
 acosh.class.sources := cyclone_objects/binaries/control/acosh.c
 asinh.class.sources := cyclone_objects/binaries/control/asinh.c
 atanh.class.sources := cyclone_objects/binaries/control/atanh.c
@@ -118,7 +149,6 @@
 pong~.class.sources := cyclone_objects/binaries/audio/pong.c
 pow~.class.sources := cyclone_objects/binaries/audio/pow.c
 rampsmooth~.class.sources := cyclone_objects/binaries/audio/rampsmooth.c
-rand~.class.sources := cyclone_objects/binaries/audio/rand.c
 reson~.class.sources := cyclone_objects/binaries/audio/reson.c
 sampstoms~.class.sources := cyclone_objects/binaries/audio/sampstoms.c
 sinh~.class.sources := cyclone_objects/binaries/audio/sinh.c
@@ -169,53 +199,3 @@
 tosymbol.class.sources := cyclone_objects/binaries/control/tosymbol.c $(hgrow)
 append.class.sources := cyclone_objects/binaries/control/append.c $(hgrow)
 clip.class.sources := cyclone_objects/binaries/control/clip.c $(hgrow)
-prepend.class.sources := cyclone_objects/binaries/control/prepend.c $(hgrow)
-thresh.class.sources := cyclone_objects/binaries/control/thresh.c $(hgrow)
-substitute.class.sources := cyclone_objects/binaries/control/substitute.c $(hgrow)
-speedlim.class.sources := cyclone_objects/binaries/control/speedlim.c $(hgrow)
-match.class.sources := cyclone_objects/binaries/control/match.c $(hgrow)
-iter.class.sources := cyclone_objects/binaries/control/iter.c $(hgrow)
-buddy.class.sources := cyclone_objects/binaries/control/buddy.c $(hgrow)
-bondo.class.sources := cyclone_objects/binaries/control/bondo.c $(hgrow)
-pv.class.sources := cyclone_objects/binaries/control/pv.c $(hgrow)
-
-hrandfile := \
-shared/control/rand.c \
-shared/common/file.c
-prob.class.sources := cyclone_objects/binaries/control/prob.c $(hrandfile)
-
-hgui := shared/control/gui.c
-active.class.sources := cyclone_objects/binaries/control/active.c $(hgui)
-mousefilter.class.sources := cyclone_objects/binaries/control/mousefilter.c $(hgui)
-mousestate.class.sources := cyclone_objects/binaries/control/mousestate.c $(hgui)
-
-htree := shared/control/tree.c
-offer.class.sources := cyclone_objects/binaries/control/offer.c $(htree)
-
-htreefile := \
-shared/control/tree.c \
-shared/common/file.c
-funbuff.class.sources := cyclone_objects/binaries/control/funbuff.c $(htreefile)
-
-hrand := shared/control/rand.c
-drunk.class.sources := cyclone_objects/binaries/control/drunk.c $(hrand)
-
-hrandgrow := \
-shared/control/rand.c \
-shared/common/grow.c
-urn.class.sources := cyclone_objects/binaries/control/urn.c $(hrandgrow)
-
-hrandgrowfile := \
-shared/control/rand.c \
-shared/common/grow.c \
-shared/common/file.c
-table.class.sources := cyclone_objects/binaries/control/table.c $(hrandgrowfile)
-
-hseq := \
-shared/control/mifi.c \
-shared/common/file.c \
-shared/common/grow.c
-seq.class.sources := cyclone_objects/binaries/control/seq.c $(hseq)
-
-# New Dependencies:
-

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,6 @@
  IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
 Build-Depends:
  debhelper-compat (= 13),
- dh-buildinfo,
  dh-sequence-puredata,
 Standards-Version: 4.7.2
 Rules-Requires-Root: no

=== debian/rules ===
#!/usr/bin/make -f
# Copyright © 2010 Hans-Christoph Steiner <hans@eds.org>
# Copyright © 2018 IOhannes m zmölnig <umlaeute@debian.org>

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ --buildsystem=pd_lib_builder

DEB_COPYRIGHT_CHECK_IGNORE_REGEX = \
        debian/.*|.*wav|README\.pdf

# licensecheck v1
.PHONY: licensecheck
licensecheck:
	LANG=C.UTF-8 licensecheck \
		-i "^($(DEB_COPYRIGHT_CHECK_IGNORE_REGEX))$$" \
		--check '.*' --recursive --deb-machine --lines 0 * \
		> debian/copyright_newhints
	cmp debian/copyright_hints debian/copyright_newhints \
		&& rm debian/copyright_newhints

=== debian/watch ===
# process with uscan(1)
version=4
opts=uversionmangle=s/(alpha|beta)/~$1/;s/^cyclone[-_]//;s/^\.//;s/-/./g,\
     repacksuffix=+ds,\
     dversionmangle=auto \
  https://github.com/porres/pd-cyclone/tags .*/(cyclone[-_])?v?(\d\S*)\.tar\.gz
